#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

#define SALT_LEN 64
#define MAX_PASSWORD_LEN 128

#include "str.c"
#include "md5.c"
#include "stdpass.c"

struct MD5Context md5struct;

char *make_salt(void)
{
  static char salt[SALT_LEN];
  unsigned char randomtime;
  unsigned n = 0;

  __asm
  {
    mov ah, 0x2C
    int 0x21
    add randomtime, ch
    add randomtime, cl
    add randomtime, dh
    add randomtime, dl
  }

  srand(randomtime);

  while(n<SALT_LEN)
    salt[n++] = rand();  

  return salt;
}

int main(int argc, char **argv)
{
  unsigned n = 0;
  unsigned char digest[16];
  char *salt = make_salt();
  char pass[MAX_PASSWORD_LEN];
  char pass2[MAX_PASSWORD_LEN];
  FILE *fp;
  MD5Init(&md5struct);

  if(argc == 2)
  {
    if(str_len(argv[1]) > 8)
    {
      printf("Too long username!");
      return 5;
    }
    
    printf("Enter password for user %s: \n", argv[1]);
    getpass(pass);
    printf("Repeat password for user %s: \n", argv[1]);
    getpass(pass2);
    if(strcmp(pass, pass2))
    {
      printf("Passwords did not match!\n");
      return 3;
    }        
    
    MD5Update(&md5struct, pass, str_len(pass));

    printf("Using salt: ");
    while(n<SALT_LEN)
      printf("%X ", salt[n++]);

    n=0;

    MD5Update(&md5struct, salt, SALT_LEN);
    
    MD5Final(digest, &md5struct);
    printf("\n\nMD5 hash: ");
    while(n<16)
      printf("%X ", digest[n++]);

    fp = fopen(argv[1], "wb");
    if(fp)
    {
      printf("\nWriting login information to file %s ...\n", argv[1]);
      fwrite(digest, 1, 16, fp);
      fwrite(salt, 1, SALT_LEN, fp);
      fclose(fp);
      printf("Done!\n");

      return 0;
    }
    else
    {
      printf("\nError while creating file!\n");
      return 1;
    }
  }

  printf("Program usage: \n$ adduser [username]\nThe password will be saved to a file named [username].\n");

  return 2;
    
}
